OGRE-Next: Ogre::GL3PlusRenderSystem Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Public Member Functions | List of all members
Ogre::GL3PlusRenderSystem Class Referencefinal

Implementation of GL 3 as a rendering system. More...

`#include <OgreGL3PlusRenderSystem.h>`

Inheritance diagram for Ogre::GL3PlusRenderSystem:
[legend]

## Public Member Functions
| GL3PlusRenderSystem (const NameValuePairList *options)
| ~GL3PlusRenderSystem () override
void | _beginFrame () override
| See RenderSystem.
void | _convertOpenVrProjectionMatrix (const Matrix4 &matrix, Matrix4 &dest) override
| Converts an OpenVR projection matrix to have the proper depth range and reverse Z settings.
void | _convertProjectionMatrix (const Matrix4 &matrix, Matrix4 &dest) override
| See RenderSystem.
Window * | _createRenderWindow (const String &name, uint32 width, uint32 height, bool fullScreen, const NameValuePairList *miscParams=0) override
| Creates a new rendering window.
bool | _createRenderWindows (const RenderWindowDescriptionList &renderWindowDescriptions, WindowList &createdWindows) override
| Creates multiple rendering windows.
void | _descriptorSetTexture2Created (DescriptorSetTexture2 *newSet) override
void | _descriptorSetTexture2Destroyed (DescriptorSetTexture2 *set) override
void | _descriptorSetUavCreated (DescriptorSetUav *newSet) override
void | _descriptorSetUavDestroyed (DescriptorSetUav *set) override
void | _dispatch (const HlmsComputePso &pso) override
void | _endFrame () override
| See RenderSystem.
GL3PlusFrameBufferDescMap & | _getFrameBufferDescMap ()
GL3PlusContext * | _getMainContext ()
| Returns the main context.
void | _hlmsBlendblockCreated (HlmsBlendblock *newBlock) override
void | _hlmsBlendblockDestroyed (HlmsBlendblock *block) override
void | _hlmsComputePipelineStateObjectCreated (HlmsComputePso *newPso) override
void | _hlmsComputePipelineStateObjectDestroyed (HlmsComputePso *newPso) override
void | _hlmsMacroblockCreated (HlmsMacroblock *newBlock) override
void | _hlmsMacroblockDestroyed (HlmsMacroblock *block) override
void | _hlmsPipelineStateObjectCreated (HlmsPso *newPso) override
void | _hlmsPipelineStateObjectDestroyed (HlmsPso *pso) override
void | _hlmsSamplerblockCreated (HlmsSamplerblock *newBlock) override
void | _hlmsSamplerblockDestroyed (HlmsSamplerblock *block) override
Window * | _initialise (bool autoCreateWindow, const String &windowTitle="OGRE Render Window") override
| See RenderSystem.
void | _makeRsProjectionMatrix (const Matrix4 &matrix, Matrix4 &dest, Real nearPlane, Real farPlane, ProjectionType projectionType) override
| Takes a regular source projection matrix in range [-1; 1] and converts it to a projection matrix in 'dest' with reverse Z range [1; 0].
void | _oneTimeContextInitialization ()
| One time initialization for the RenderState of a context.
void | _render (const CbDrawCallIndexed *cmd) override
| Renders the VAO. Assumes _setVertexArrayObject has already been called.
void | _render (const CbDrawCallStrip *cmd) override
void | _render (const v1::CbDrawCallIndexed *cmd) override
| Renders a V1 RenderOperation. Assumes _setRenderOperation has already been called.
void | _render (const v1::CbDrawCallStrip *cmd) override
void | _render (const v1::RenderOperation &op) override
| See RenderSystem.
void | _renderEmulated (const CbDrawCallIndexed *cmd) override
void | _renderEmulated (const CbDrawCallStrip *cmd) override
void | _renderEmulatedNoBaseInstance (const CbDrawCallIndexed *cmd) override
void | _renderEmulatedNoBaseInstance (const CbDrawCallStrip *cmd) override
void | _renderNoBaseInstance (const v1::CbDrawCallIndexed *cmd) override
void | _renderNoBaseInstance (const v1::CbDrawCallStrip *cmd) override
void | _setComputePso (const HlmsComputePso *pso) override
| Unlike _setPipelineStateObject, the RenderSystem will check if the PSO has changed to avoid redundant state changes (since it's hard to do it at Hlms level)
void | _setCurrentDeviceFromTexture (TextureGpu *texture) override
| Because Ogre doesn't (yet) have the notion of a 'device' or 'GL context', this function lets Ogre know which device should be used by providing a texture.
void | _setDepthBias (float constantBias, float slopeScaleBias)
| See RenderSystem.
void | _setGeometryTexture (size_t unit, TextureGpu *tex) override
| See RenderSystem.
void | _setHlmsBlendblock (const HlmsBlendblock *blendblock, const GL3PlusHlmsPso *pso)
void | _setHlmsMacroblock (const HlmsMacroblock *macroblock, const GL3PlusHlmsPso *pso)
void | _setHlmsSamplerblock (uint8 texUnit, const HlmsSamplerblock *samplerblock) override
| See HlmsSamplerblock.
void | _setIndirectBuffer (IndirectBufferPacked *indirectBuffer) override
void | _setPipelineStateObject (const HlmsPso *pso) override
void | _setPointParameters (Real size, bool attenuationEnabled, Real constant, Real linear, Real quadratic, Real minSize, Real maxSize) override
| See RenderSystem.
void | _setPointSpritesEnabled (bool enabled) override
| See RenderSystem.
void | _setProjectionMatrix (const Matrix4 &m) override
| See RenderSystem.
void | _setRenderOperation (const v1::CbRenderOp *cmd) override
void | _setSamplers (uint32 slotStart, const DescriptorSetSampler *set) override
void | _setSamplersCS (uint32 slotStart, const DescriptorSetSampler *set) override
void | _setSceneBlending (SceneBlendFactor sourceFactor, SceneBlendFactor destFactor, SceneBlendOperation op)
void | _setSceneBlendingOperation (SceneBlendOperation op)
void | _setSeparateSceneBlending (SceneBlendFactor sourceFactor, SceneBlendFactor destFactor, SceneBlendFactor sourceFactorAlpha, SceneBlendFactor destFactorAlpha, SceneBlendOperation op, SceneBlendOperation alphaOp)
void | _setSeparateSceneBlendingOperation (SceneBlendOperation op, SceneBlendOperation alphaOp)
void | _setSurfaceParams (const ColourValue &ambient, const ColourValue &diffuse, const ColourValue &specular, const ColourValue &emissive, Real shininess, TrackVertexColourType tracking) override
| See RenderSystem.
void | _setTessellationDomainTexture (size_t unit, TextureGpu *tex) override
| See RenderSystem.
void | _setTessellationHullTexture (size_t unit, TextureGpu *tex) override
| See RenderSystem.
void | _setTexture (size_t unit, TextureGpu *tex, bool bDepthReadOnly) override
| See RenderSystem.
void | _setTextureBlendMode (size_t stage, const LayerBlendModeEx &bm) override
| See RenderSystem.
void | _setTextureCoordCalculation (size_t stage, TexCoordCalcMethod m, const Frustum *frustum=0) override
| See RenderSystem.
void | _setTextureMatrix (size_t stage, const Matrix4 &xform) override
| See RenderSystem.
void | _setTextures (uint32 slotStart, const DescriptorSetTexture *set, uint32 hazardousTexIdx) override
| See RenderSystem.
void | _setTextures (uint32 slotStart, const DescriptorSetTexture2 *set) override
void | _setTexturesCS (uint32 slotStart, const DescriptorSetTexture *set) override
void | _setTexturesCS (uint32 slotStart, const DescriptorSetTexture2 *set) override
void | _setUavCS (uint32 slotStart, const DescriptorSetUav *set) override
void | _setVertexArrayObject (const VertexArrayObject *vao) override
| Part of the low level rendering interface.
void | _setVertexTexture (size_t unit, TextureGpu *tex) override
| See RenderSystem.
void | _setViewMatrix (const Matrix4 &m) override
| See RenderSystem.
void | _setWorldMatrix (const Matrix4 &m) override
| See RenderSystem.
void | _startLegacyV1Rendering () override
| May override the current VertexArrayObject!
void | _switchContext (GL3PlusContext *context)
| Switch GL context, dealing with involved internal cached states too.
void | _unregisterContext (GL3PlusContext *context)
| Unregister a render target->context mapping.
void | _useLights (const LightList &, unsigned short) override
| See RenderSystem.
bool | areFixedFunctionLightsInViewSpace () const override
| See RenderSystem.
void | beginGPUSampleProfile (const String &name, uint32 *hashCache) override
void | beginProfileEvent (const String &eventName) override
| This marks the beginning of an event for GPU profiling.
void | beginRenderPassDescriptor (RenderPassDescriptor *desc, TextureGpu *anyTarget, uint8 mipLevel, const Vector4 *viewportSizes, const Vector4 *scissors, uint32 numViewports, bool overlaysEnabled, bool warnIfRtvWasFlushed) override
| When the descriptor is set to Load clear, two possible things may happen:
void | bindGpuProgramParameters (GpuProgramType gptype, GpuProgramParametersSharedPtr params, uint16 mask) override
| Bind Gpu program parameters.
void | bindGpuProgramPassIterationParameters (GpuProgramType gptype) override
| Only binds Gpu program parameters used for passes that have more than one iteration rendering.
void | clearFrameBuffer (RenderPassDescriptor *renderPassDesc, TextureGpu *anyTarget, uint8 mipLevel) override
| Immediately clears the whole frame buffer on the selected RenderPassDescriptor.
GLenum | convertCompareFunction (CompareFunction func) const
GLenum | convertStencilOp (StencilOperation op) const
TextureGpu * | createDepthBufferFor (TextureGpu *colourTexture, bool preferDepthTexture, PixelFormatGpu depthBufferFormat, uint16 poolId) override
HardwareOcclusionQuery * | createHardwareOcclusionQuery () override
| Create an object for performing hardware occlusion queries.
RenderPassDescriptor * | createRenderPassDescriptor () override
RenderSystemCapabilities * | createRenderSystemCapabilities () const override
| See RenderSystem.
void | debugAnnotationPop () override
void | debugAnnotationPush (const String &event) override
| Specifically meant to mark passes in RenderDoc.
void | deinitGPUProfiling () override
void | enableClipPlane (ushort index, bool enable)
| See RenderSystem.
void | endGPUSampleProfile (const String &name) override
void | endProfileEvent () override
| Ends the currently active GPU profiling event.
void | endRenderPassDescriptor () override
void | executeResourceTransition (const ResourceTransitionArray &rstCollection) override
void | flushUAVs ()
VertexElementType | getColourVertexElementType () const override
| See RenderSystem.
ConfigOptionMap & | getConfigOptions () override
| See RenderSystem.
unsigned int | getDisplayMonitorCount () const override
| Gets the number of display monitors.
String | getErrorDescription (long errorNumber) const override
| See RenderSystem.
const String & | getFriendlyName () const override
| See RenderSystem.
const GL3PlusSupport * | getGLSupport () const
Real | getHorizontalTexelOffset () override
| Returns the horizontal texel offset value required for mapping texel origins to pixel origins in this rendersystem.
Real | getMaximumDepthInputValue () override
| Gets the maximum (farthest) depth value to be used when rendering using identity transforms.
Real | getMinimumDepthInputValue () override
| Gets the minimum (closest) depth value to be used when rendering using identity transforms.
const String & | getName () const override
| See RenderSystem.
size_t | getNumPriorityConfigOptions () const override
| Number of priority config options in RenderSystem::getPriorityConfigOption.
const char * | getPriorityConfigOption (size_t idx) const override
| Some options depend on other options.
Real | getRSDepthRange () const override
| OpenGL depth is in range [-1;1] so it returns 2.0f; D3D11 & Metal are in range [0;1] so it returns 1.0f;.
Real | getVerticalTexelOffset () override
| Returns the vertical texel offset value required for mapping texel origins to pixel origins in this rendersystem.
bool | hasAnisotropicMipMapFilter () const override
| Determines if the system has anisotropic mip map filter support.
void | initGPUProfiling () override
void | initialiseContext (Window *primary)
void | initialiseFromRenderSystemCapabilities (RenderSystemCapabilities *caps, Window *primary) override
| See RenderSystem.
void | markProfileEvent (const String &eventName) override
| Marks an instantaneous event for graphics profilers.
| OGRE_MUTEX (mThreadInitMutex)
void | postExtraThreadsStarted () override
void | preExtraThreadsStarted () override
| Tell the rendersystem to perform any prep tasks it needs to directly before other threads which might access the rendering API are registered.
void | registerThread () override
| Register the an additional thread which may make calls to rendersystem-related objects.
void | reinitialise () override
| See RenderSystem.
void | setClipPlane (ushort index, Real A, Real B, Real C, Real D)
| See RenderSystem.
void | setClipPlanesImpl (const Ogre::PlaneList &planeList) override
| Internal method used to set the underlying clip planes when needed.
void | setConfigOption (const String &name, const String &value) override
| See RenderSystem.
void | setStencilBufferParams (uint32 refValue, const StencilParams &stencilParams) override
| See RenderSystem.
void | shutdown () override
| See RenderSystem.
bool | supportsTargetIndependentRasterization () const
void | unregisterThread () override
| Unregister an additional thread which may make calls to rendersystem-related objects.
String | validateConfigOptions () override
| See RenderSystem.
Public Member Functions inherited from Ogre::RenderSystem
| RenderSystem ()
| Default Constructor.
virtual | ~RenderSystem ()
| Destructor.
void | _addMetrics (const RenderingMetrics &newMetrics)
virtual void | _beginFrameOnce ()
| Signifies the beginning of the main frame.
void | _cleanupDepthBuffers ()
void | _dereferenceSharedDepthBuffer (TextureGpu *depthBuffer)
| Releases the reference count on a shared depth buffer.
virtual void | _descriptorSetSamplerCreated (DescriptorSetSampler *newSet)
virtual void | _descriptorSetSamplerDestroyed (DescriptorSetSampler *set)
virtual void | _descriptorSetTextureCreated (DescriptorSetTexture *newSet)
virtual void | _descriptorSetTextureDestroyed (DescriptorSetTexture *set)
virtual void | _endFrameOnce ()
| Called once per frame, regardless of how many active workspaces there are.
Viewport & | _getCurrentRenderViewport ()
virtual const String & | _getDefaultViewportMaterialScheme () const
| Returns the default material scheme used by the render system.
virtual RenderSystemContext * | _pauseFrame ()
| Pause rendering for a frame.
void | _resetMetrics ()
virtual void | _resumeFrame (RenderSystemContext *context)
| Resume rendering for a frame.
virtual void | _setBindingType (TextureUnitState::BindingType bindigType)
| Set texture unit binding type.
virtual void | _setTextureProjectionRelativeTo (bool enabled, const Vector3 &pos)
| Notify the rendersystem that it should adjust texture projection to be relative to a different origin.
virtual void | _setTextureUnitSettings (size_t texUnit, TextureUnitState &tl)
| Utility function for setting all the properties of a texture unit at once.
virtual void | _setWorldMatrices (const Matrix4 *m, unsigned short count)
| Sets multiple world matrices (vertex blending).
void | _update ()
| Called once per frame, regardless of how many active workspaces there are.
virtual void | addClipPlane (const Plane &p)
| Add a user clipping plane.
virtual void | addClipPlane (Real A, Real B, Real C, Real D)
| Add a user clipping plane.
virtual void | addListener (Listener *l)
| Adds a listener to the custom events that this render system can raise.
virtual void | compositorWorkspaceBegin (CompositorWorkspace *workspace, const bool forceBeginFrame)
| See RenderSystem::updateCompositorManager.
virtual void | compositorWorkspaceEnd (CompositorWorkspace *workspace, const bool forceEndFrame)
| See RenderSystem::updateCompositorManager.
virtual void | compositorWorkspaceUpdate (CompositorWorkspace *workspace)
| See RenderSystem::updateCompositorManager.
virtual void | convertColourValue (const ColourValue &colour, uint32 *pDest)
| Generates a packed data version of the passed in ColourValue suitable for use as with this RenderSystem.
virtual void | destroyHardwareOcclusionQuery (HardwareOcclusionQuery *hq)
| Destroy a hardware occlusion query object.
void | destroyRenderPassDescriptor (RenderPassDescriptor *renderPassDesc)
virtual void | destroyRenderWindow (Window *window)
| Destroys a render window.
virtual void | endCopyEncoder ()
| Required when caller will soon start analyzing barriers (e.g.
virtual void | endGpuDebuggerFrameCapture (Window *window, const bool bDiscard=false)
| See RenderSystem::startGpuDebuggerFrameCapture Call this function when you're done capturing a frame.
virtual void | executeRenderPassDescriptorDelayedActions ()
| Metal needs to delay RenderCommand creation to the last minute, because we can't issue blit operations (e.g.
BarrierSolver & | getBarrierSolver ()
BoundUav | getBoundUav (size_t slot) const
const RenderSystemCapabilities * | getCapabilities () const
| Gets the capabilities of the render system.
RenderPassDescriptor * | getCurrentPassDescriptor ()
Viewport * | getCurrentRenderViewports ()
virtual void | getCustomAttribute (const String &name, void *pData)
| Gets a custom (maybe platform-specific) attribute.
bool | getDebugShaders () const
virtual TextureGpu * | getDepthBufferFor (TextureGpu *colourTexture, uint16 poolId, bool preferDepthTexture, PixelFormatGpu depthBufferFormat)
virtual const DriverVersion & | getDriverVersion () const
| Returns the driver version.
v1::HardwareVertexBufferSharedPtr | getGlobalInstanceVertexBuffer () const
| Returns the global instance vertex buffer.
v1::VertexDeclaration * | getGlobalInstanceVertexBufferVertexDeclaration () const
| Gets vertex declaration for the global vertex buffer for the global instancing.
size_t | getGlobalNumberOfInstances () const
| Gets the global number of instances.
bool | getInvertedClipSpaceY () const
| +Y is downwards in NDC (Normalized Device Coordinates). Only Vulkan has this problem.
virtual bool | getInvertVertexWinding () const
| Indicates whether or not the vertex windings set will be inverted for the current render (e.g.
uint32 | getMaxBoundViewports ()
const RenderingMetrics & | getMetrics () const
RenderSystemCapabilities * | getMutableCapabilities ()
| Get a pointer to the current capabilities being used by the RenderSystem.
uint16 | getNativeShadingLanguageVersion () const
| Gets the native shading language version for this render system.
RENDERDOC_API_1_4_1 * | getRenderDocApi ()
| Returns the RenderDoc API handle in case you want to do more advanced functionality than what we expose.
virtual const StringVector & | getRenderSystemEvents () const
| Gets a list of the rendersystem specific events that this rendersystem can raise.
const StencilParams & | getStencilBufferParams () const
TextureGpuManager * | getTextureGpuManager () const
VaoManager * | getVaoManager () const
bool | getWBufferEnabled () const
| Returns true if the renderer will try to use W-buffers when available.
virtual bool | isGpuProgramBound (GpuProgramType gptype)
| Returns whether or not a Gpu program of the given type is currently bound.
bool | isReverseDepth () const
virtual bool | isSameLayout (ResourceLayout::Layout a, ResourceLayout::Layout b, const TextureGpu *texture, bool bIsDebugCheck) const
| Returns true if 'a' and 'b' internally map to the same layout and should be considered equivalent for a given texture.
virtual bool | isStaticBufferLockable () const
bool | loadRenderDocApi ()
| Explicitly loads RenderDoc.
void | queueBindUAVs (const DescriptorSetUav *descSetUav)
| Queues the binding of an UAV to the binding point/slot.
virtual void | removeListener (Listener *l)
| Remove a listener to the custom events that this render system can raise.
virtual void | resetClipPlanes ()
| Clears the user clipping region.
virtual void | setClipPlanes (const PlaneList &clipPlanes)
| Sets the user clipping region.
virtual void | setCurrentPassIterationCount (const size_t count)
| set the current multi pass count value.
void | setDebugShaders (bool bDebugShaders)
| Instructs the RenderSystem to compile shaders without optimizations and with debug information, for easier debugging on APIs that support it.
virtual void | setDeriveDepthBias (bool derive, float baseValue=0.0f, float multiplier=0.0f, float slopeScale=0.0f)
| Tell the render system whether to derive a depth bias on its own based on the values passed to it in setCurrentPassIterationCount.
void | setGlobalInstanceVertexBuffer (const v1::HardwareVertexBufferSharedPtr &val)
| Sets the global instance vertex buffer.
void | setGlobalInstanceVertexBufferVertexDeclaration (v1::VertexDeclaration *val)
| Sets vertex declaration for the global vertex buffer for the global instancing.
void | setGlobalNumberOfInstances (const size_t val)
| Sets the global number of instances.
void | setInvertVertexWinding (bool invert)
| Sets whether or not vertex windings set should be inverted; this can be important for rendering reflections.
void | setMetricsRecordingEnabled (bool bEnable)
void | setUavStartingSlot (uint32 startingSlot)
| In Direct3D11, UAV & RenderTargets share the same slots.
void | setWBufferEnabled (bool enabled)
| Sets whether or not W-buffers are enabled if they are available for this renderer.
virtual bool | startGpuDebuggerFrameCapture (Window *window)
| Programmatically performs a GPU capture when attached to a GPU debugger like RenderDoc or Metal Graphics Debugger.
virtual void | updateCompositorManager (CompositorManager2 *compositorManager)
| This gives the renderer a chance to perform the compositor update in a special way.
virtual void | useCustomRenderSystemCapabilities (RenderSystemCapabilities *capabilities)
| Force the render system to use the special capabilities.
virtual bool | validateDevice (bool forceDeviceElection=false)
| Some render systems have moments when GPU device is temporarily unavailable, for example when D3D11 device is lost, or when iOS app is in background, etc.
virtual SampleDescription | validateSampleDescription (const SampleDescription &sampleDesc, PixelFormatGpu format)
| Returns supported sample description for requested FSAA mode, with graceful downgrading.

## Additional Inherited Members
Static Public Member Functions inherited from Ogre::RenderSystem
static void | addSharedListener (Listener *listener)
| Sets shared listener.
static void | fireSharedEvent (const String &name, const NameValuePairList *params=0)
static void | removeSharedListener (Listener *listener)
| Remove shared listener to the custom events that this render system can raise.
static CompareFunction | reverseCompareFunction (CompareFunction depthFunc)
| Reverts the compare order e.g.

## Detailed Description

Implementation of GL 3 as a rendering system.

## Constructor & Destructor Documentation

## ◆ GL3PlusRenderSystem()

Ogre::GL3PlusRenderSystem::GL3PlusRenderSystem | ( | const NameValuePairList * | options | ) |

## ◆ ~GL3PlusRenderSystem()

Ogre::GL3PlusRenderSystem::~GL3PlusRenderSystem | ( |  | ) |
| override

## Member Function Documentation

## ◆ _beginFrame()

void Ogre::GL3PlusRenderSystem::_beginFrame | ( |  | ) |
| overridevirtual

See RenderSystem.

Implements Ogre::RenderSystem.

## ◆ _convertOpenVrProjectionMatrix()

void Ogre::GL3PlusRenderSystem::_convertOpenVrProjectionMatrix | ( | const Matrix4 & | matrix,
|  | Matrix4 & | dest )
| overridevirtual

Converts an OpenVR projection matrix to have the proper depth range and reverse Z settings.

Parameters

  matrix |
  dest |

Reimplemented from Ogre::RenderSystem.

## ◆ _convertProjectionMatrix()

void Ogre::GL3PlusRenderSystem::_convertProjectionMatrix | ( | const Matrix4 & | matrix,
|  | Matrix4 & | dest )
| overridevirtual

See RenderSystem.

Reimplemented from Ogre::RenderSystem.

## ◆ _createRenderWindow()

Window * Ogre::GL3PlusRenderSystem::_createRenderWindow | ( | const String & | name,
|  | uint32 | width,
|  | uint32 | height,
|  | bool | fullScreen,
|  | const NameValuePairList * | miscParams = 0 )
| overridevirtual

Creates a new rendering window.

Remarks
  This method creates a new rendering window as specified by the paramteters. The rendering system could be responible for only a single window (e.g. in the case of a game), or could be in charge of multiple ones (in the case of a level editor). The option to create the window as a child of another is therefore given. This method will create an appropriate subclass of RenderWindow depending on the API and platform implementation.

  After creation, this window can be retrieved using getRenderTarget().

Parameters

  name | The name of the window. Used in other methods later like setRenderTarget and getRenderTarget.
  width | The width of the new window.
  height | The height of the new window.
  fullScreen | Specify true to make the window full screen without borders, title bar or menu bar.
  miscParams | A NameValuePairList describing the other parameters for the new rendering window. Options are case sensitive. Unrecognised parameters will be ignored silently. These values might be platform dependent, but these are present for all platforms unless indicated otherwise:
  Key | Type/Values | Default | Description | Notes
  title | Any string | RenderTarget name | The title of the window that will appear in the title bar |
  colourDepth | 16, 32 | Desktop depth | Colour depth of the resulting rendering window; only applies if fullScreen | Win32 Specific
  left | Positive integers | Centred | Screen x coordinate from left |
  top | Positive integers | Centred | Screen y coordinate from left |
  depthBuffer | true, false | true | Use depth buffer | DirectX9 specific
  externalWindowHandle | Win32: HWND as integer GLX: poslong:posint:poslong (display*:screen:windowHandle) or poslong:posint:poslong:poslong (display*:screen:windowHandle:XVisualInfo*) OS X Cocoa: OgreGLView address as an integer. You can pass NSView or NSWindow too, but should perform OgreGLView callbacks into the Ogre manually. iOS: UIWindow address as an integer | 0 (none) | External window handle, for embedding the OGRE render in an existing window |
  externalGLControl | true, false | false | Let the external window control OpenGL i.e. don't select a pixel format for the window, do not change v-sync and do not swap buffer. When set to true, the calling application is responsible of OpenGL initialization and buffer swapping. It should also create an OpenGL context for its own rendering, Ogre will create one for its use. Then the calling application must also enable Ogre OpenGL context before calling any Ogre function and restore its OpenGL context after these calls. | OpenGL specific
  externalGLContext | Context as Unsigned Long | 0 (create own context) | Use an externally created GL context | OpenGL Specific
  parentWindowHandle | Win32: HWND as integer GLX: poslong:posint:poslong (display*:screen:windowHandle) or poslong:posint:poslong:poslong (display*:screen:windowHandle:XVisualInfo*) | 0 (none) | Parent window handle, for embedding the OGRE in a child of an external window |
  contentScalingFactor | Positive Float greater than 1.0 | The default content scaling factor of the screen | Specifies the CAEAGLLayer content scaling factor. Only supported on iOS 4 or greater. This can be useful to limit the resolution of the OpenGL ES backing store. For example, the iPhone 4's native resolution is 960 x 640. Windows are always 320 x 480, if you would like to limit the display to 720 x 480, specify 1.5 as the scaling factor. | iOS Specific |
  externalViewHandle | UIView pointer as an integer | 0 | External view handle, for rendering OGRE render in an existing view | iOS Specific |
  externalViewControllerHandle | UIViewController pointer as an integer | 0 | External view controller handle, for embedding OGRE in an existing view controller | iOS Specific |
  externalSharegroup | EAGLSharegroup pointer as an integer | 0 | External sharegroup, used to shared GL resources between contexts | iOS Specific |
  Full Screen | true, false | false | Specify whether to create the window in full screen mode | OS X Specific |
  MSAA | Positive integer (usually 1, 2, 4, 8, 16) | 1 | Multisample antialiasing factor |
  MSAA_Quality | Depends on RenderSystem and hardware. Currently supports: 0 ... infinite number (depends on HW) | Blank | Full screen antialiasing hint |
  displayFrequency | Refresh rate in Hertz (e.g. 60, 75, 100) | Desktop vsync rate | Display frequency rate, for fullscreen mode |
  vsync | true, false | false | Synchronize buffer swaps to monitor vsync, eliminating tearing at the expense of a fixed frame rate |
  vsyncInterval | 1, 2, 3, 4 | 1 | If vsync is enabled, the minimum number of vertical blanks that should occur between renders. For example if vsync is enabled, the refresh rate is 60 and this is set to 2, then the frame rate will be locked at 30. |
  border | none, fixed, resize | resize | The type of window border (in windowed mode) |
  outerDimensions | true, false | false | Whether the width/height is expressed as the size of the outer window, rather than the content area |
  useNVPerfHUD | true, false | false | Enable the use of nVidia NVPerfHUD |
  gamma | true, false | false | Enable hardware conversion from linear colour space to gamma colour space on rendering to the window. |
  enableDoubleClick | true, false | false | Enable the window to keep track and transmit double click messages. | Win32 Specific
  MSAA | Positive integer (usually 0, 2, 4, 8, 16) | 0 | Full screen antialiasing factor | Android Specific
  CSAA | Positive integer (usually 0, 2, 4, 8, 16) | 0 | Coverage sampling factor (https://www.khronos.org/registry/egl/extensions/NV/EGL_NV_coverage_sample.txt) | Android Specific
  maxColourBufferSize | Positive integer (usually 16, 32) | 32 | Max EGL_BUFFER_SIZE | Android Specific
  minColourBufferSize | Positive integer (usually 16, 32) | 16 | Min EGL_BUFFER_SIZE | Android Specific
  maxStencilBufferSize | Positive integer (usually 0, 8) | 0 | EGL_STENCIL_SIZE | Android Specific
  maxDepthBufferSize | Positive integer (usually 0, 16, 24) | 16 | EGL_DEPTH_SIZE | Android Specific

Implements Ogre::RenderSystem.

## ◆ _createRenderWindows()

bool Ogre::GL3PlusRenderSystem::_createRenderWindows | ( | const RenderWindowDescriptionList & | renderWindowDescriptions,
|  | WindowList & | createdWindows )
| overridevirtual

Creates multiple rendering windows.

Parameters

  renderWindowDescriptions | Array of structures containing the descriptions of each render window. The structure's members are the same as the parameters of _createRenderWindow: name width height fullScreen miscParams See _createRenderWindow for details about each member.
  createdWindows | This array will hold the created render windows.

Returns
  true on success.

Reimplemented from Ogre::RenderSystem.

## ◆ _descriptorSetTexture2Created()

void Ogre::GL3PlusRenderSystem::_descriptorSetTexture2Created | ( | DescriptorSetTexture2 * | newSet | ) |
| overridevirtual

Reimplemented from Ogre::RenderSystem.

## ◆ _descriptorSetTexture2Destroyed()

void Ogre::GL3PlusRenderSystem::_descriptorSetTexture2Destroyed | ( | DescriptorSetTexture2 * | set | ) |
| overridevirtual

Reimplemented from Ogre::RenderSystem.

## ◆ _descriptorSetUavCreated()

void Ogre::GL3PlusRenderSystem::_descriptorSetUavCreated | ( | DescriptorSetUav * | newSet | ) |
| overridevirtual

Reimplemented from Ogre::RenderSystem.

## ◆ _descriptorSetUavDestroyed()

void Ogre::GL3PlusRenderSystem::_descriptorSetUavDestroyed | ( | DescriptorSetUav * | set | ) |
| overridevirtual

Reimplemented from Ogre::RenderSystem.

## ◆ _dispatch()

void Ogre::GL3PlusRenderSystem::_dispatch | ( | const HlmsComputePso & | pso | ) |
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ _endFrame()

void Ogre::GL3PlusRenderSystem::_endFrame | ( |  | ) |
| overridevirtual

See RenderSystem.

Implements Ogre::RenderSystem.

## ◆ _getFrameBufferDescMap()

GL3PlusFrameBufferDescMap & Ogre::GL3PlusRenderSystem::_getFrameBufferDescMap | ( |  | ) |
| inline

## ◆ _getMainContext()

GL3PlusContext * Ogre::GL3PlusRenderSystem::_getMainContext | ( |  | ) |
| inline

Returns the main context.

## ◆ _hlmsBlendblockCreated()

void Ogre::GL3PlusRenderSystem::_hlmsBlendblockCreated | ( | HlmsBlendblock * | newBlock | ) |
| overridevirtual

Reimplemented from Ogre::RenderSystem.

## ◆ _hlmsBlendblockDestroyed()

void Ogre::GL3PlusRenderSystem::_hlmsBlendblockDestroyed | ( | HlmsBlendblock * | block | ) |
| overridevirtual

Reimplemented from Ogre::RenderSystem.

## ◆ _hlmsComputePipelineStateObjectCreated()

void Ogre::GL3PlusRenderSystem::_hlmsComputePipelineStateObjectCreated | ( | HlmsComputePso * | newPso | ) |
| overridevirtual

Reimplemented from Ogre::RenderSystem.

## ◆ _hlmsComputePipelineStateObjectDestroyed()

void Ogre::GL3PlusRenderSystem::_hlmsComputePipelineStateObjectDestroyed | ( | HlmsComputePso * | newPso | ) |
| overridevirtual

Reimplemented from Ogre::RenderSystem.

## ◆ _hlmsMacroblockCreated()

void Ogre::GL3PlusRenderSystem::_hlmsMacroblockCreated | ( | HlmsMacroblock * | newBlock | ) |
| overridevirtual

Reimplemented from Ogre::RenderSystem.

## ◆ _hlmsMacroblockDestroyed()

void Ogre::GL3PlusRenderSystem::_hlmsMacroblockDestroyed | ( | HlmsMacroblock * | block | ) |
| overridevirtual

Reimplemented from Ogre::RenderSystem.

## ◆ _hlmsPipelineStateObjectCreated()

void Ogre::GL3PlusRenderSystem::_hlmsPipelineStateObjectCreated | ( | HlmsPso * | newPso | ) |
| overridevirtual

Reimplemented from Ogre::RenderSystem.

## ◆ _hlmsPipelineStateObjectDestroyed()

void Ogre::GL3PlusRenderSystem::_hlmsPipelineStateObjectDestroyed | ( | HlmsPso * | pso | ) |
| overridevirtual

Reimplemented from Ogre::RenderSystem.

## ◆ _hlmsSamplerblockCreated()

void Ogre::GL3PlusRenderSystem::_hlmsSamplerblockCreated | ( | HlmsSamplerblock * | newBlock | ) |
| overridevirtual

Reimplemented from Ogre::RenderSystem.

## ◆ _hlmsSamplerblockDestroyed()

void Ogre::GL3PlusRenderSystem::_hlmsSamplerblockDestroyed | ( | HlmsSamplerblock * | block | ) |
| overridevirtual

Reimplemented from Ogre::RenderSystem.

## ◆ _initialise()

Window * Ogre::GL3PlusRenderSystem::_initialise | ( | bool | autoCreateWindow,
|  | const String & | windowTitle = "OGRE Render Window" )
| overridevirtual

See RenderSystem.

Reimplemented from Ogre::RenderSystem.

## ◆ _makeRsProjectionMatrix()

void Ogre::GL3PlusRenderSystem::_makeRsProjectionMatrix | ( | const Matrix4 & | matrix,
|  | Matrix4 & | dest,
|  | Real | nearPlane,
|  | Real | farPlane,
|  | ProjectionType | projectionType )
| overridevirtual

Takes a regular source projection matrix in range [-1; 1] and converts it to a projection matrix in 'dest' with reverse Z range [1; 0].

_convertProjectionMatrix does the same thing but is more generic. This version assumes a standard projection matrix (i.e. not oblique) to maximize precision

Parameters

  matrix |
  dest |
  nearPlane |
  farPlane |
  projectionType |

Reimplemented from Ogre::RenderSystem.

## ◆ _oneTimeContextInitialization()

void Ogre::GL3PlusRenderSystem::_oneTimeContextInitialization | ( |  | ) |

One time initialization for the RenderState of a context.

Things that only need to be set once, like the LightingModel can be defined here.

## ◆ _render() [1/5]

void Ogre::GL3PlusRenderSystem::_render | ( | const CbDrawCallIndexed * | cmd | ) |
| overridevirtual

Renders the VAO. Assumes _setVertexArrayObject has already been called.

Implements Ogre::RenderSystem.

## ◆ _render() [2/5]

void Ogre::GL3PlusRenderSystem::_render | ( | const CbDrawCallStrip * | cmd | ) |
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ _render() [3/5]

void Ogre::GL3PlusRenderSystem::_render | ( | const v1::CbDrawCallIndexed * | cmd | ) |
| overridevirtual

Renders a V1 RenderOperation. Assumes _setRenderOperation has already been called.

Implements Ogre::RenderSystem.

## ◆ _render() [4/5]

void Ogre::GL3PlusRenderSystem::_render | ( | const v1::CbDrawCallStrip * | cmd | ) |
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ _render() [5/5]

void Ogre::GL3PlusRenderSystem::_render | ( | const v1::RenderOperation & | op | ) |
| overridevirtual

See RenderSystem.

Reimplemented from Ogre::RenderSystem.

## ◆ _renderEmulated() [1/2]

void Ogre::GL3PlusRenderSystem::_renderEmulated | ( | const CbDrawCallIndexed * | cmd | ) |
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ _renderEmulated() [2/2]

void Ogre::GL3PlusRenderSystem::_renderEmulated | ( | const CbDrawCallStrip * | cmd | ) |
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ _renderEmulatedNoBaseInstance() [1/2]

void Ogre::GL3PlusRenderSystem::_renderEmulatedNoBaseInstance | ( | const CbDrawCallIndexed * | cmd | ) |
| overridevirtual

Reimplemented from Ogre::RenderSystem.

## ◆ _renderEmulatedNoBaseInstance() [2/2]

void Ogre::GL3PlusRenderSystem::_renderEmulatedNoBaseInstance | ( | const CbDrawCallStrip * | cmd | ) |
| overridevirtual

Reimplemented from Ogre::RenderSystem.

## ◆ _renderNoBaseInstance() [1/2]

void Ogre::GL3PlusRenderSystem::_renderNoBaseInstance | ( | const v1::CbDrawCallIndexed * | cmd | ) |
| overridevirtual

Reimplemented from Ogre::RenderSystem.

## ◆ _renderNoBaseInstance() [2/2]

void Ogre::GL3PlusRenderSystem::_renderNoBaseInstance | ( | const v1::CbDrawCallStrip * | cmd | ) |
| overridevirtual

Reimplemented from Ogre::RenderSystem.

## ◆ _setComputePso()

void Ogre::GL3PlusRenderSystem::_setComputePso | ( | const HlmsComputePso * | pso | ) |
| overridevirtual

Unlike _setPipelineStateObject, the RenderSystem will check if the PSO has changed to avoid redundant state changes (since it's hard to do it at Hlms level)

Implements Ogre::RenderSystem.

## ◆ _setCurrentDeviceFromTexture()

void Ogre::GL3PlusRenderSystem::_setCurrentDeviceFromTexture | ( | TextureGpu * | texture | ) |
| overridevirtual

Because Ogre doesn't (yet) have the notion of a 'device' or 'GL context', this function lets Ogre know which device should be used by providing a texture.

Parameters

  texture | Cannot be null.

Implements Ogre::RenderSystem.

## ◆ _setDepthBias()

void Ogre::GL3PlusRenderSystem::_setDepthBias | ( | float | constantBias,
|  | float | slopeScaleBias )

See RenderSystem.

## ◆ _setGeometryTexture()

void Ogre::GL3PlusRenderSystem::_setGeometryTexture | ( | size_t | unit,
|  | TextureGpu * | tex )
| overridevirtual

See RenderSystem.

Reimplemented from Ogre::RenderSystem.

## ◆ _setHlmsBlendblock()

void Ogre::GL3PlusRenderSystem::_setHlmsBlendblock | ( | const HlmsBlendblock * | blendblock,
|  | const GL3PlusHlmsPso * | pso )

## ◆ _setHlmsMacroblock()

void Ogre::GL3PlusRenderSystem::_setHlmsMacroblock | ( | const HlmsMacroblock * | macroblock,
|  | const GL3PlusHlmsPso * | pso )

## ◆ _setHlmsSamplerblock()

void Ogre::GL3PlusRenderSystem::_setHlmsSamplerblock | ( | uint8 | texUnit,
|  | const HlmsSamplerblock * | Samplerblock )
| overridevirtual

See HlmsSamplerblock.

This function MUST be called after _setTexture, not before. Otherwise not all APIs may see the change.

Implements Ogre::RenderSystem.

## ◆ _setIndirectBuffer()

void Ogre::GL3PlusRenderSystem::_setIndirectBuffer | ( | IndirectBufferPacked * | indirectBuffer | ) |
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ _setPipelineStateObject()

void Ogre::GL3PlusRenderSystem::_setPipelineStateObject | ( | const HlmsPso * | pso | ) |
| overridevirtual

See also
  HlmsPso

Reimplemented from Ogre::RenderSystem.

## ◆ _setPointParameters()

void Ogre::GL3PlusRenderSystem::_setPointParameters | ( | Real | size,
|  | bool | attenuationEnabled,
|  | Real | constant,
|  | Real | linear,
|  | Real | quadratic,
|  | Real | minSize,
|  | Real | maxSize )
| overridevirtual

See RenderSystem.

Implements Ogre::RenderSystem.

## ◆ _setPointSpritesEnabled()

void Ogre::GL3PlusRenderSystem::_setPointSpritesEnabled | ( | bool | enabled | ) |
| overridevirtual

See RenderSystem.

Implements Ogre::RenderSystem.

## ◆ _setProjectionMatrix()

void Ogre::GL3PlusRenderSystem::_setProjectionMatrix | ( | const Matrix4 & | m | ) |
| overridevirtual

See RenderSystem.

Implements Ogre::RenderSystem.

## ◆ _setRenderOperation()

void Ogre::GL3PlusRenderSystem::_setRenderOperation | ( | const v1::CbRenderOp * | cmd | ) |
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ _setSamplers()

void Ogre::GL3PlusRenderSystem::_setSamplers | ( | uint32 | slotStart,
|  | const DescriptorSetSampler * | set )
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ _setSamplersCS()

void Ogre::GL3PlusRenderSystem::_setSamplersCS | ( | uint32 | slotStart,
|  | const DescriptorSetSampler * | set )
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ _setSceneBlending()

void Ogre::GL3PlusRenderSystem::_setSceneBlending | ( | SceneBlendFactor | sourceFactor,
|  | SceneBlendFactor | destFactor,
|  | SceneBlendOperation | op )

## ◆ _setSceneBlendingOperation()

void Ogre::GL3PlusRenderSystem::_setSceneBlendingOperation | ( | SceneBlendOperation | op | ) |

## ◆ _setSeparateSceneBlending()

void Ogre::GL3PlusRenderSystem::_setSeparateSceneBlending | ( | SceneBlendFactor | sourceFactor,
|  | SceneBlendFactor | destFactor,
|  | SceneBlendFactor | sourceFactorAlpha,
|  | SceneBlendFactor | destFactorAlpha,
|  | SceneBlendOperation | op,
|  | SceneBlendOperation | alphaOp )

## ◆ _setSeparateSceneBlendingOperation()

void Ogre::GL3PlusRenderSystem::_setSeparateSceneBlendingOperation | ( | SceneBlendOperation | op,
|  | SceneBlendOperation | alphaOp )

## ◆ _setSurfaceParams()

void Ogre::GL3PlusRenderSystem::_setSurfaceParams | ( | const ColourValue & | ambient,
|  | const ColourValue & | diffuse,
|  | const ColourValue & | specular,
|  | const ColourValue & | emissive,
|  | Real | shininess,
|  | TrackVertexColourType | tracking )
| inlineoverridevirtual

See RenderSystem.

Implements Ogre::RenderSystem.

## ◆ _setTessellationDomainTexture()

void Ogre::GL3PlusRenderSystem::_setTessellationDomainTexture | ( | size_t | unit,
|  | TextureGpu * | tex )
| overridevirtual

See RenderSystem.

Reimplemented from Ogre::RenderSystem.

## ◆ _setTessellationHullTexture()

void Ogre::GL3PlusRenderSystem::_setTessellationHullTexture | ( | size_t | unit,
|  | TextureGpu * | tex )
| overridevirtual

See RenderSystem.

Reimplemented from Ogre::RenderSystem.

## ◆ _setTexture()

void Ogre::GL3PlusRenderSystem::_setTexture | ( | size_t | unit,
|  | TextureGpu * | tex,
|  | bool | bDepthReadOnly )
| overridevirtual

See RenderSystem.

Implements Ogre::RenderSystem.

## ◆ _setTextureBlendMode()

void Ogre::GL3PlusRenderSystem::_setTextureBlendMode | ( | size_t | stage,
|  | const LayerBlendModeEx & | bm )
| inlineoverridevirtual

See RenderSystem.

Implements Ogre::RenderSystem.

## ◆ _setTextureCoordCalculation()

void Ogre::GL3PlusRenderSystem::_setTextureCoordCalculation | ( | size_t | stage,
|  | TexCoordCalcMethod | m,
|  | const Frustum * | frustum = 0 )
| inlineoverridevirtual

See RenderSystem.

Implements Ogre::RenderSystem.

## ◆ _setTextureMatrix()

void Ogre::GL3PlusRenderSystem::_setTextureMatrix | ( | size_t | stage,
|  | const Matrix4 & | xform )
| inlineoverridevirtual

See RenderSystem.

Implements Ogre::RenderSystem.

## ◆ _setTextures() [1/2]

void Ogre::GL3PlusRenderSystem::_setTextures | ( | uint32 | slotStart,
|  | const DescriptorSetTexture * | set,
|  | uint32 | hazardousTexIdx )
| overridevirtual

See RenderSystem.

Implements Ogre::RenderSystem.

## ◆ _setTextures() [2/2]

void Ogre::GL3PlusRenderSystem::_setTextures | ( | uint32 | slotStart,
|  | const DescriptorSetTexture2 * | set )
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ _setTexturesCS() [1/2]

void Ogre::GL3PlusRenderSystem::_setTexturesCS | ( | uint32 | slotStart,
|  | const DescriptorSetTexture * | set )
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ _setTexturesCS() [2/2]

void Ogre::GL3PlusRenderSystem::_setTexturesCS | ( | uint32 | slotStart,
|  | const DescriptorSetTexture2 * | set )
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ _setUavCS()

void Ogre::GL3PlusRenderSystem::_setUavCS | ( | uint32 | slotStart,
|  | const DescriptorSetUav * | set )
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ _setVertexArrayObject()

void Ogre::GL3PlusRenderSystem::_setVertexArrayObject | ( | const VertexArrayObject * | vao | ) |
| overridevirtual

Part of the low level rendering interface.

Tells the RS which VAO will be bound now. (i.e. Vertex Formats, buffers being bound, etc.) You don't need to rebind if the VAO's mRenderQueueId is the same as previous call.

Remarks
  Assumes _setPipelineStateObject has already been called.

Implements Ogre::RenderSystem.

## ◆ _setVertexTexture()

void Ogre::GL3PlusRenderSystem::_setVertexTexture | ( | size_t | unit,
|  | TextureGpu * | tex )
| overridevirtual

See RenderSystem.

Reimplemented from Ogre::RenderSystem.

## ◆ _setViewMatrix()

void Ogre::GL3PlusRenderSystem::_setViewMatrix | ( | const Matrix4 & | m | ) |
| overridevirtual

See RenderSystem.

Implements Ogre::RenderSystem.

## ◆ _setWorldMatrix()

void Ogre::GL3PlusRenderSystem::_setWorldMatrix | ( | const Matrix4 & | m | ) |
| overridevirtual

See RenderSystem.

Implements Ogre::RenderSystem.

## ◆ _startLegacyV1Rendering()

void Ogre::GL3PlusRenderSystem::_startLegacyV1Rendering | ( |  | ) |
| overridevirtual

May override the current VertexArrayObject!

Reimplemented from Ogre::RenderSystem.

## ◆ _switchContext()

void Ogre::GL3PlusRenderSystem::_switchContext | ( | GL3PlusContext * | context | ) |

Switch GL context, dealing with involved internal cached states too.

## ◆ _unregisterContext()

void Ogre::GL3PlusRenderSystem::_unregisterContext | ( | GL3PlusContext * | context | ) |

Unregister a render target->context mapping.

If the context of target is the current context, change the context to the main context so it can be destroyed safely.

Note
  This is automatically called by the destructor of GL3PlusContext.

## ◆ _useLights()

void Ogre::GL3PlusRenderSystem::_useLights | ( | const LightList & | ,
|  | unsigned short | )
| inlineoverridevirtual

See RenderSystem.

Implements Ogre::RenderSystem.

## ◆ areFixedFunctionLightsInViewSpace()

bool Ogre::GL3PlusRenderSystem::areFixedFunctionLightsInViewSpace | ( |  | ) | const
| inlineoverridevirtual

See RenderSystem.

Reimplemented from Ogre::RenderSystem.

## ◆ beginGPUSampleProfile()

void Ogre::GL3PlusRenderSystem::beginGPUSampleProfile | ( | const String & | name,
|  | uint32 * | hashCache )
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ beginProfileEvent()

void Ogre::GL3PlusRenderSystem::beginProfileEvent | ( | const String & | eventName | ) |
| overridevirtual

This marks the beginning of an event for GPU profiling.

Implements Ogre::RenderSystem.

## ◆ beginRenderPassDescriptor()

void Ogre::GL3PlusRenderSystem::beginRenderPassDescriptor | ( | RenderPassDescriptor * | desc,
|  | TextureGpu * | anyTarget,
|  | uint8 | mipLevel,
|  | const Vector4 * | viewportSizes,
|  | const Vector4 * | scissors,
|  | uint32 | numViewports,
|  | bool | overlaysEnabled,
|  | bool | warnIfRtvWasFlushed )
| overridevirtual

When the descriptor is set to Load clear, two possible things may happen:

1. The region is cleared.
2. The whole texture is cleared. What actually happens is undefined (depends on the API). But calling "beginRenderPassDescriptor( desc, viewportSettings );" with the same descriptor but different viewports (without changing the desc) guarantees that each region is cleared:

1. Each time the subregion is switched
2. Only once (the whole texture), when the first viewport was set.
     When switching between render targets, two beginRenderPassDescriptor in a row automatically implies calls endRenderPassDescriptor. In fact this is faster to perfom than calling beginRenderPassDescriptor - endRenderPassDescriptor in pairs, because we can smartly flush only what needs to be flushed. endRenderPassDescriptor only needs to be called when no other beginRenderPassDescriptor will follow (i.e. at the end of the frame or when starting compute jobs)
   Parameters

     desc |
     anyTarget | Contains the first valid texture in mRenderPassDesc, to be used for reference (e.g. width, height, etc). Could be colour, depth, stencil, or nullptr.
     mipLevel | Mip at which anyTarget is bound
     viewportSize |
     warnIfRtvWasFlushed | See CompositorPassDef::mWarnIfRtvWasFlushed

Reimplemented from Ogre::RenderSystem.

## ◆ bindGpuProgramParameters()

void Ogre::GL3PlusRenderSystem::bindGpuProgramParameters | ( | GpuProgramType | gptype,
|  | GpuProgramParametersSharedPtr | params,
|  | uint16 | variabilityMask )
| overridevirtual

Bind Gpu program parameters.

Parameters

  gptype | The type of program to bind the parameters to
  params | The parameters to bind
  variabilityMask | A mask of GpuParamVariability identifying which params need binding

Implements Ogre::RenderSystem.

## ◆ bindGpuProgramPassIterationParameters()

void Ogre::GL3PlusRenderSystem::bindGpuProgramPassIterationParameters | ( | GpuProgramType | gptype | ) |
| overridevirtual

Only binds Gpu program parameters used for passes that have more than one iteration rendering.

Implements Ogre::RenderSystem.

## ◆ clearFrameBuffer()

void Ogre::GL3PlusRenderSystem::clearFrameBuffer | ( | RenderPassDescriptor * | renderPassDesc,
|  | TextureGpu * | anyTarget,
|  | uint8 | mipLevel )
| overridevirtual

Immediately clears the whole frame buffer on the selected RenderPassDescriptor.

Prefer clearing using the LoadAction semantics in the RenderPassDescriptor. This function is provided for two reasons:

1. Backwards compatibility (i.e. easier porting from 2.1)
2. Non-tilers desktop GPUs may be faster to clear the whole framebuffer at once.
   Remarks
     Will break an existing RenderPassDescriptor set via beginRenderPassDescriptor.
   Parameters

     renderPassDesc | RenderPassDescriptor filled with LoadActions set to clear and StoreActions set to Store.

Implements Ogre::RenderSystem.

## ◆ convertCompareFunction()

GLenum Ogre::GL3PlusRenderSystem::convertCompareFunction | ( | CompareFunction | func | ) | const

## ◆ convertStencilOp()

GLenum Ogre::GL3PlusRenderSystem::convertStencilOp | ( | StencilOperation | op | ) | const

## ◆ createDepthBufferFor()

TextureGpu * Ogre::GL3PlusRenderSystem::createDepthBufferFor | ( | TextureGpu * | colourTexture,
|  | bool | preferDepthTexture,
|  | PixelFormatGpu | depthBufferFormat,
|  | uint16 | poolId )
| overridevirtual

Reimplemented from Ogre::RenderSystem.

## ◆ createHardwareOcclusionQuery()

HardwareOcclusionQuery * Ogre::GL3PlusRenderSystem::createHardwareOcclusionQuery | ( |  | ) |
| overridevirtual

Create an object for performing hardware occlusion queries.

Implements Ogre::RenderSystem.

## ◆ createRenderPassDescriptor()

RenderPassDescriptor * Ogre::GL3PlusRenderSystem::createRenderPassDescriptor | ( |  | ) |
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ createRenderSystemCapabilities()

RenderSystemCapabilities * Ogre::GL3PlusRenderSystem::createRenderSystemCapabilities | ( |  | ) | const
| overridevirtual

See RenderSystem.

Implements Ogre::RenderSystem.

## ◆ debugAnnotationPop()

void Ogre::GL3PlusRenderSystem::debugAnnotationPop | ( |  | ) |
| overridevirtual

Reimplemented from Ogre::RenderSystem.

## ◆ debugAnnotationPush()

void Ogre::GL3PlusRenderSystem::debugAnnotationPush | ( | const String & | event | ) |
| overridevirtual

Specifically meant to mark passes in RenderDoc.

See https://renderdoc.org/docs/how/how_annotate_capture.html

In many cases it will use the same interface as beginProfileEvent / endProfileEvent

Note: For security & performance reasons this feature is only enabled when OGRE_DEBUG_MODE >= OGRE_DEBUG_MEDIUM

Reimplemented from Ogre::RenderSystem.

## ◆ deinitGPUProfiling()

void Ogre::GL3PlusRenderSystem::deinitGPUProfiling | ( |  | ) |
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ enableClipPlane()

void Ogre::GL3PlusRenderSystem::enableClipPlane | ( | ushort | index,
|  | bool | enable )

See RenderSystem.

## ◆ endGPUSampleProfile()

void Ogre::GL3PlusRenderSystem::endGPUSampleProfile | ( | const String & | name | ) |
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ endProfileEvent()

void Ogre::GL3PlusRenderSystem::endProfileEvent | ( |  | ) |
| overridevirtual

Ends the currently active GPU profiling event.

Implements Ogre::RenderSystem.

## ◆ endRenderPassDescriptor()

void Ogre::GL3PlusRenderSystem::endRenderPassDescriptor | ( |  | ) |
| overridevirtual

Reimplemented from Ogre::RenderSystem.

## ◆ executeResourceTransition()

void Ogre::GL3PlusRenderSystem::executeResourceTransition | ( | const ResourceTransitionArray & | rstCollection | ) |
| overridevirtual

Reimplemented from Ogre::RenderSystem.

## ◆ flushUAVs()

void Ogre::GL3PlusRenderSystem::flushUAVs | ( |  | ) |

## ◆ getColourVertexElementType()

VertexElementType Ogre::GL3PlusRenderSystem::getColourVertexElementType | ( |  | ) | const
| overridevirtual

See RenderSystem.

Implements Ogre::RenderSystem.

## ◆ getConfigOptions()

ConfigOptionMap & Ogre::GL3PlusRenderSystem::getConfigOptions | ( |  | ) |
| overridevirtual

See RenderSystem.

Implements Ogre::RenderSystem.

## ◆ getDisplayMonitorCount()

unsigned int Ogre::GL3PlusRenderSystem::getDisplayMonitorCount | ( |  | ) | const
| overridevirtual

Gets the number of display monitors.

See also
  Root::getDisplayMonitorCount

Implements Ogre::RenderSystem.

## ◆ getErrorDescription()

String Ogre::GL3PlusRenderSystem::getErrorDescription | ( | long | errorNumber | ) | const
| overridevirtual

See RenderSystem.

Implements Ogre::RenderSystem.

## ◆ getFriendlyName()

const String & Ogre::GL3PlusRenderSystem::getFriendlyName | ( |  | ) | const
| overridevirtual

See RenderSystem.

Implements Ogre::RenderSystem.

## ◆ getGLSupport()

const GL3PlusSupport * Ogre::GL3PlusRenderSystem::getGLSupport | ( |  | ) | const
| inline

## ◆ getHorizontalTexelOffset()

Real Ogre::GL3PlusRenderSystem::getHorizontalTexelOffset | ( |  | ) |
| inlineoverridevirtual

Returns the horizontal texel offset value required for mapping texel origins to pixel origins in this rendersystem.

Remarks
  Since rendersystems sometimes disagree on the origin of a texel, mapping from texels to pixels can sometimes be problematic to implement generically. This method allows you to retrieve the offset required to map the origin of a texel to the origin of a pixel in the horizontal direction.

Implements Ogre::RenderSystem.

## ◆ getMaximumDepthInputValue()

Real Ogre::GL3PlusRenderSystem::getMaximumDepthInputValue | ( |  | ) |
| overridevirtual

Gets the maximum (farthest) depth value to be used when rendering using identity transforms.

Remarks
  When using identity transforms you can manually set the depth of a vertex; however the input values required differ per rendersystem. This method lets you retrieve the correct value.

See also
  Renderable::getUseIdentityView, Renderable::getUseIdentityProjection

Implements Ogre::RenderSystem.

## ◆ getMinimumDepthInputValue()

Real Ogre::GL3PlusRenderSystem::getMinimumDepthInputValue | ( |  | ) |
| overridevirtual

Gets the minimum (closest) depth value to be used when rendering using identity transforms.

Remarks
  When using identity transforms you can manually set the depth of a vertex; however the input values required differ per rendersystem. This method lets you retrieve the correct value.

See also
  Renderable::getUseIdentityView, Renderable::getUseIdentityProjection

Implements Ogre::RenderSystem.

## ◆ getName()

const String & Ogre::GL3PlusRenderSystem::getName | ( |  | ) | const
| overridevirtual

See RenderSystem.

Implements Ogre::RenderSystem.

## ◆ getNumPriorityConfigOptions()

size_t Ogre::GL3PlusRenderSystem::getNumPriorityConfigOptions | ( |  | ) | const
| overridevirtual

Number of priority config options in RenderSystem::getPriorityConfigOption.

Remarks
  IMPORTANT: The return value can change after calls to setConfigOption, it can even return higher or lower values than before.

Therefore a proper loop would call getNumPriorityConfigOptions on every iteration:

// GOOD:
for( size_t i=0; i < rs->getNumPriorityConfigOptions(); ++i )
rs->setConfigOption( rs->getPriorityConfigOption( i ), value );
// BAD:
const size_t cachedNumOptions = rs->getNumPriorityConfigOptions();
for( size_t i=0; i < cachedNumOptions; ++i )
rs->setConfigOption( rs->getPriorityConfigOption( i ), value );

Reimplemented from Ogre::RenderSystem.

## ◆ getPriorityConfigOption()

const char * Ogre::GL3PlusRenderSystem::getPriorityConfigOption | ( | size_t | idx | ) | const
| overridevirtual

Some options depend on other options.

Therefore it's best to call RenderSystem::setConfigOption in order

Parameters

  idx | Value must be in range [0; getNumPriorityConfigOptions)

Options must be set in ascending order, i.e. idx = 0 must be called before idx = 1

Returns
  The name to use in setConfigOption( name, value )

Reimplemented from Ogre::RenderSystem.

## ◆ getRSDepthRange()

Real Ogre::GL3PlusRenderSystem::getRSDepthRange | ( |  | ) | const
| overridevirtual

OpenGL depth is in range [-1;1] so it returns 2.0f; D3D11 & Metal are in range [0;1] so it returns 1.0f;.

Note OpenGL may behave like D3D11, and thus we'll return 1.0f too. This is decided at runtime, not at compile time.

Reimplemented from Ogre::RenderSystem.

## ◆ getVerticalTexelOffset()

Real Ogre::GL3PlusRenderSystem::getVerticalTexelOffset | ( |  | ) |
| inlineoverridevirtual

Returns the vertical texel offset value required for mapping texel origins to pixel origins in this rendersystem.

Remarks
  Since rendersystems sometimes disagree on the origin of a texel, mapping from texels to pixels can sometimes be problematic to implement generically. This method allows you to retrieve the offset required to map the origin of a texel to the origin of a pixel in the vertical direction.

Implements Ogre::RenderSystem.

## ◆ hasAnisotropicMipMapFilter()

bool Ogre::GL3PlusRenderSystem::hasAnisotropicMipMapFilter | ( |  | ) | const
| inlineoverridevirtual

Determines if the system has anisotropic mip map filter support.

Implements Ogre::RenderSystem.

## ◆ initGPUProfiling()

void Ogre::GL3PlusRenderSystem::initGPUProfiling | ( |  | ) |
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ initialiseContext()

void Ogre::GL3PlusRenderSystem::initialiseContext | ( | Window * | primary | ) |

## ◆ initialiseFromRenderSystemCapabilities()

void Ogre::GL3PlusRenderSystem::initialiseFromRenderSystemCapabilities | ( | RenderSystemCapabilities * | caps,
|  | Window * | primary )
| overridevirtual

See RenderSystem.

Implements Ogre::RenderSystem.

## ◆ markProfileEvent()

void Ogre::GL3PlusRenderSystem::markProfileEvent | ( | const String & | eventName | ) |
| overridevirtual

Marks an instantaneous event for graphics profilers.

This is equivalent to calling beginProfileEvent() and endProfileEvent() back to back.

Implements Ogre::RenderSystem.

## ◆ OGRE_MUTEX()

Ogre::GL3PlusRenderSystem::OGRE_MUTEX | ( | mThreadInitMutex |  | ) |

## ◆ postExtraThreadsStarted()

void Ogre::GL3PlusRenderSystem::postExtraThreadsStarted | ( |  | ) |
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ preExtraThreadsStarted()

void Ogre::GL3PlusRenderSystem::preExtraThreadsStarted | ( |  | ) |
| overridevirtual

Tell the rendersystem to perform any prep tasks it needs to directly before other threads which might access the rendering API are registered.

Remarks
  Call this from your main thread before starting your other threads (which themselves should call registerThread()). Note that if you start your own threads, there is a specific startup sequence which must be respected and requires synchronisation between the threads:
  1. [Main thread]Call preExtraThreadsStarted
  2. [Main thread]Start other thread, wait
  3. [Other thread]Call registerThread, notify main thread & continue
  4. [Main thread]Wake up & call postExtraThreadsStarted
  Once this init sequence is completed the threads are independent but this startup sequence must be respected.

Implements Ogre::RenderSystem.

## ◆ registerThread()

void Ogre::GL3PlusRenderSystem::registerThread | ( |  | ) |
| overridevirtual

Register the an additional thread which may make calls to rendersystem-related objects.

Remarks
  This method should only be called by additional threads during their initialisation. If they intend to use hardware rendering system resources they should call this method before doing anything related to the render system. Some rendering APIs require a per-thread setup and this method will sort that out. It is also necessary to call unregisterThread before the thread shuts down.

Note
  This method takes no parameters - it must be called from the thread being registered and that context is enough.

Implements Ogre::RenderSystem.

## ◆ reinitialise()

void Ogre::GL3PlusRenderSystem::reinitialise | ( |  | ) |
| overridevirtual

See RenderSystem.

Implements Ogre::RenderSystem.

## ◆ setClipPlane()

void Ogre::GL3PlusRenderSystem::setClipPlane | ( | ushort | index,
|  | Real | A,
|  | Real | B,
|  | Real | C,
|  | Real | D )

See RenderSystem.

## ◆ setClipPlanesImpl()

void Ogre::GL3PlusRenderSystem::setClipPlanesImpl | ( | const Ogre::PlaneList & | clipPlanes | ) |
| overridevirtual

Internal method used to set the underlying clip planes when needed.

Implements Ogre::RenderSystem.

## ◆ setConfigOption()

void Ogre::GL3PlusRenderSystem::setConfigOption | ( | const String & | name,
|  | const String & | value )
| overridevirtual

See RenderSystem.

Implements Ogre::RenderSystem.

## ◆ setStencilBufferParams()

void Ogre::GL3PlusRenderSystem::setStencilBufferParams | ( | uint32 | refValue,
|  | const StencilParams & | stencilParams )
| overridevirtual

See RenderSystem.

Reimplemented from Ogre::RenderSystem.

## ◆ shutdown()

void Ogre::GL3PlusRenderSystem::shutdown | ( |  | ) |
| overridevirtual

See RenderSystem.

Reimplemented from Ogre::RenderSystem.

## ◆ supportsTargetIndependentRasterization()

bool Ogre::GL3PlusRenderSystem::supportsTargetIndependentRasterization | ( |  | ) | const
| inline

## ◆ unregisterThread()

void Ogre::GL3PlusRenderSystem::unregisterThread | ( |  | ) |
| overridevirtual

Unregister an additional thread which may make calls to rendersystem-related objects.

See also
  RenderSystem::registerThread

Implements Ogre::RenderSystem.

## ◆ validateConfigOptions()

String Ogre::GL3PlusRenderSystem::validateConfigOptions | ( |  | ) |
| overridevirtual

See RenderSystem.

Implements Ogre::RenderSystem.

The documentation for this class was generated from the following file:

- OgreGL3PlusRenderSystem.h